Description

Please consider supporting comma in Wiki macro.

I have considered using double quotes and I'm attaching a patch.

This patch supports the following two additional features.

1. Double quotes can be escaped by placing two consecutive double quotes.

2. Support for enclosing values in double quotes in key/value pair arguments.

For example:

args = 

'a,    "b, bbb,  b", cc c, """d, ""d""", "e" , hh,  , "", """", jj=jj, kk="kk, k", "ll=l,ll"'

args = args.split(/\s*,\s*(?=(?:[^"]*"[^"]*")*[^"]*$)/).map{|i| i.gsub(/^"(.*)"$/, '\1').gsub('""'

, '"')}

# args:

["a", "b, bbb,  b", "cc c", "\"d, \"d\"", "e", "hh", "", "", "\"", "jj=jj", "kk=\"kk, k\"", 

"ll=l,ll"]

Related issues:

Related to Redmine - Defect #41153: {{collapse(custom text)}} macro cuts off ... Closed

Associated revisions

Revision 22959 - 2024-08-20 04:13 - Go MAEDA

Add support for quoted arguments containing commas in wiki macros (#40014).

Patch by Yasu Saku (user:skys).

History

#1 - 2024-08-15 09:03 - Go MAEDA

- Related to Defect #41153: {{collapse(custom text)}} macro cuts off at first comma added

#2 - 2024-08-17 06:30 - Go MAEDA

- File 40014-test.patch added

- Target version set to Candidate for next major release

Thank you for posting the patch.

I wrote a test for this change.

#3 - 2024-08-19 03:32 - Go MAEDA

- Category changed from Wiki to Text formatting

- Target version changed from Candidate for next major release to 6.0.0

Setting the target version to 6.0.0.

#4 - 2024-08-20 04:13 - Go MAEDA

- Subject changed from Comma support in Wiki macro with double quotes to Add support for quoted arguments containing commas in wiki macros
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch with a test in r22959. Thank you for your contribution.

#5 - 2024-08-20 07:52 - Marius BĂLTEANU

What do you think if we merge this fix small improvement to stable branches?

Files

support-comma-with-double-quotes.patch 934 Bytes 2024-01-08 Yasu Saku

40014-test.patch 845 Bytes 2024-08-17 Go MAEDA
